# ModifyInstanceTrafficPackage

## 1. API Description

This API (ModifyInstanceTrafficPackage) is used to The API is used to modify the traffic package of an instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">You can only perform this operation on instances whose status is</mark> <mark style="color:blue;">`RUNNING or STOPPED`</mark><mark style="color:blue;">.</mark>
* <mark style="color:blue;">If the</mark> [<mark style="color:purple;">`internetChargeType`</mark>](/api-reference/compute/bmc/datastructure.md#internetchargetype) <mark style="color:blue;">of your instance is</mark> <mark style="color:blue;">`ByTrafficPackage`</mark>
  * <mark style="color:blue;">For a</mark> <mark style="color:blue;">`PREPAID`</mark> <mark style="color:blue;">instance:</mark>
    * <mark style="color:blue;">Upgrade (target > current) operation will deduct the amount required for this instance purchase. If the balance is insufficient, the request will fail and take effect immediately.</mark>
    * <mark style="color:blue;">Downgrade (target < current) operation will generate an order for the next billing cycle and will take effect by then.</mark>
* <mark style="color:blue;">Use</mark> <mark style="color:blue;">`InquiryPriceInstanceTrafficPackage`</mark> <mark style="color:blue;">to query price of traffic package.</mark>
* <mark style="color:blue;">Use</mark> <mark style="color:blue;">`DescribeInstanceInternetStatus`</mark> <mark style="color:blue;">to query bandwidth status of an instance.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name     | Required | Type   | Description                                                                                                                  |
| ------------------ | -------- | ------ | ---------------------------------------------------------------------------------------------------------------------------- |
| instanceId         | Yes      | String | <p>Instance ID.</p><p>To obtain the instance ID, you can call DescribeInstances and look for instanceId in the response.</p> |
| trafficPackageSize | Yes      | Float  | <p>Traffic package size.</p><p>The value must be a multiple of 0.05.</p><p>Value range: \[0.0, +)</p>                        |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| orderNumber    | String | Number of order.                                                                                                      |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Upgrade the traffic package of an instance**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: ModifyInstanceTrafficPackage
<Common Request Params>

Request：
{
  "instanceId": "instanceId",
  "trafficPackageSize": 100
}

Response：
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {  
    "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
    "orderNumber": "xxxx"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                                 | Description                                                                                                              |
| ---------------- | ---------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------ |
| 403              | OPERATION\_DENIED\_INSTANCE\_STATUS\_NOT\_SUPPORT          | Instance state not supported. Please power off your instance.                                                            |
| 403              | OPERATION\_FAILED\_INSTANCE\_EXIST\_PLAN\_TRAFFIC\_PACKAGE | Scheduled downgrade order exists.                                                                                        |
| 403              | OPERATION\_DENIED\_INSTANCE\_TRAFFIC\_PACKAGE\_PROCESSING  | Traffic package is being modified.                                                                                       |
| 400              | INVALID\_PARAMETER\_TRAFFIC\_PACKAGE\_LESS                 | Traffic package parameter needs to be greater than or equal to the default value.                                        |
| 400              | INVALID\_PARAMETER\_TRAFFIC\_PACKAGE\_ERROR                | Traffic package parameter validation error. Invalid value, which must be a multiple of 0.05.                             |
| 403              | OPERATION\_DENIED\_INTERNET\_CHARGE\_TYPE\_NOT\_SUPPORT    | The specified [InternetChargeType](/api-reference/compute/bmc/datastructure.md#internetchargetype) is not `ByBandwidth`. |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                              | Instance does not exist.                                                                                                 |
| 400              | INVALID\_PARAMETER\_TRAFFIC\_PACKAGE\_EXCEED               | Traffic package parameter exceeds upper limit.                                                                           |
| 403              | OPERATION\_FAILED\_INSTANCE\_NOT\_EXIST\_TRAFFIC\_PACKAGE  | The specified instance does not have a data transfer package.                                                            |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/bmc/bare-metal-instance/modifyinstancetrafficpackage.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
